import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import controlP5.*; 
import java.io.*; 
import java.util.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class hub4com_gui05 extends PApplet {

// hub4com\u5b9f\u884c\u7528GUI\u30d7\u30ed\u30b0\u30e9\u30e0
// 3\u3064\u306eCOM\u30dd\u30fc\u30c8\u3092\u63a5\u7d9a\u30fb\u5207\u65ad\u3059\u308b
// \u30dc\u30fc\u30ec\u30fc\u30c8\u8a2d\u5b9a\u6a5f\u80fd\u8ffd\u52a0
//
// 2017/10/23 \u4f0a\u85e4\u5927\u667a





ControlP5 cp5;

String textValue = "";
String[] tokens;
int clr;
int myCurrentIndex = 0;

public void setup() {
  
  
  PFont font = createFont("arial",20);
  
  cp5 = new ControlP5(this);
  
  cp5.addTextfield("COM A") // 1\u756a\u76ee\u306eCOM\u5165\u529b
     .setPosition(20,40)
     .setSize(200,40)
     .setFont(font)
     .setFocus(true)
     .setAutoClear(false)
     ;
                 
  cp5.addTextfield("COM B") // 2\u756a\u76ee\u306eCOM\u5165\u529b
     .setPosition(20,120)
     .setSize(200,40)
     .setFont(font)
     .setAutoClear(false)
     ;
  
  cp5.addTextfield("COM C")  // 3\u756a\u76ee\u306eCOM\u5165\u529b
     .setPosition(20,200)
     .setSize(200,40)
     .setFont(font)
     .setAutoClear(false)
     ;
            
  cp5.addBang("connect") // \u63a5\u7d9a\u30dc\u30bf\u30f3
     .setPosition(20,340)
     .setSize(60,40)
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ;    
     
  cp5.addBang("disconnect") // \u63a5\u7d9a\u89e3\u9664\u30dc\u30bf\u30f3
     .setPosition(90,340)
     .setSize(60,40)
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ; 
     
  cp5.addBang("clear") // \u30af\u30ea\u30a2\u30dc\u30bf\u30f3
     .setPosition(160,340)
     .setSize(60,40)
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ; 
  
  // \u30dc\u30fc\u30ec\u30fc\u30c8\u8a2d\u5b9a
  tokens = new String[10];
  tokens[0] = "9600";
  tokens[1] = "19200";
  tokens[2] = "38400";
  tokens[3] = "57600";
  tokens[4] = "115200";

  List l = Arrays.asList(tokens[0], tokens[1], tokens[2],tokens[3], tokens[4]);
     
  cp5.addScrollableList("baudrate") // \u30dc\u30fc\u30ec\u30fc\u30c8\u8a2d\u5b9a\u30ea\u30b9\u30c8
     .setPosition(20, 280)
     .setSize(200, 120)
     .setBarHeight(20)
     .setItemHeight(20)
     .addItems(l);
     
  textFont(font);
}


public void draw() {
  background(clr);
  fill(255);
  text("hub4com GUI",60,20);
  text("Baudrate [bps]",20,325);
  text(textValue, 20,410);
}


// \u30dc\u30fc\u30ec\u30fc\u30c8\u9078\u629e\u304c\u3055\u308c\u305f\u3068\u304d
public void baudrate(int n) {
 // println(n);  
  myCurrentIndex = n;  
}


// \u63a5\u7d9a\u30dc\u30bf\u30f3\u304c\u62bc\u3055\u308c\u305f\u3068\u304d
public void connect() {
  String cmdstr,strcoma,strcomb,strcomc;
  int ans;
  
  strcoma=cp5.get(Textfield.class,"COM A").getText();
  strcomb=cp5.get(Textfield.class,"COM B").getText();
  strcomc=cp5.get(Textfield.class,"COM C").getText();
  String[] location=loadStrings("hub4com_location.txt"); // hub4com\u306e\u4fdd\u5b58\u5834\u6240\u3092\u8a18\u5165
  StringBuilder buf = new StringBuilder();
  buf.append("cd ");
  buf.append(location[0]);
  buf.append(" & hub4com --route=All:All --baud=");
  buf.append(tokens[myCurrentIndex]);
  buf.append(" \\\\.\\");
  buf.append(strcoma);
  buf.append(" \\\\.\\");
  buf.append(strcomb);
  buf.append(" \\\\.\\");
  buf.append(strcomc);
  cmdstr=buf.toString();
  ans=cmd_send(cmdstr);
  System.out.println(ans);
  
  if(ans==0){
    textValue="Connected";
    clr=color(228,155,15); // \u9ec4\u91d1\u8272
  }
  else{
    textValue="Connection failure";
  }
}


// \u63a5\u7d9a\u89e3\u9664\u304c\u62bc\u3055\u308c\u305f\u3068\u304d
public void disconnect() {
  String cmdstr;
  int ans;
  cmdstr="taskkill /F /IM hub4com.exe";
  ans=cmd_send(cmdstr);
  System.out.println(ans);
  
  if(ans==0){
    textValue="Disconnected";
    clr=color(0,0,0);
  }
  else{
    textValue="Disconnection failure";
  }
  
}


// \u30af\u30ea\u30a2\u30dc\u30bf\u30f3\u304c\u62bc\u3055\u308c\u305f\u3068\u304d
public void clear() {
  cp5.get(Textfield.class,"COM A").clear();
  cp5.get(Textfield.class,"COM B").clear();
  cp5.get(Textfield.class,"COM C").clear();
}



// \u30b3\u30de\u30f3\u30c9\u30d7\u30ed\u30f3\u30d7\u30c8\u3067\u30b3\u30de\u30f3\u30c9\u3092\u5b9f\u884c\u3059\u308b\u95a2\u6570
public int cmd_send(String cmdstr){
  int ans=0;
  try{
    System.out.println(cmdstr);
    ProcessBuilder pb = new ProcessBuilder("cmd.exe","/c",cmdstr);
    Process process = pb.start();
    
    // \u7d50\u679c\u3092\u6a19\u6e96\u51fa\u529b\u306b\u66f8\u304d\u51fa\u3059
    System.out.println("\u2193\u3000\u30d7\u30ed\u30bb\u30b9\u5b9f\u884c\u7d50\u679c");
    System.out.println("==================================================================");
    BufferedReader in = new BufferedReader(new InputStreamReader(process.getInputStream()));
    String str;
    int i=0;
    while ((str = in.readLine()) != null) {
      System.out.println(str);
      i++;
      if(i>11){break;}
    }    
    System.out.println("==================================================================");
      
      // \u30d7\u30ed\u30bb\u30b9\u306eexit\u5024\u3092\u53d6\u5f97\u30fb\u8868\u793a
      System.out.println("\u30d7\u30ed\u30bb\u30b9\u306e\u7d42\u4e86\u5024 : " + process.exitValue());
      
      // \u7d42\u4e86\u51e6\u7406\u4f5c\u696d
      process.destroy();
      in.close();      
      ans=process.exitValue();
      
      }catch (Exception e) {
     println(e);
  }
  return(ans);
}
  public void settings() {  size(240,420); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "hub4com_gui05" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
